#  A mud client for
#  Dawn of the Ages  http://dawn.rplay.net
#
#  Copyright (C) 2001,2002 Peter Herth <p.herth@uni-koeln.de>
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


from Tkinter import *
from tkMessageBox import *
from tkSimpleDialog import *
from tkFileDialog import *
import traceback

import Term
import Talk
import Tool

import tkFont


import re
import string
import os

import Composer
import Verbcreator

import random
#format: (keysym, alias [,keycode])
def_key_bindings=[("F1"  , "F1"),
                  ("F2"  , "F2"),
                  ("F3"  , "F3"),
                  ("F4"  , "F4"),
                  ("F5"  , "F5"),
                  ("F6"  , "F6"),
                  ("F7"  , "F7"),
                  ("F8"  , "F8"),
                  ("F9"  , "F9"),
                  ("F10" , "F10"),
                  ("F11" , "F11"),
                  ("F12" , "F12"),
                  ("shift-F1"  , "shift-F1"),
                  ("shift-F2"  , "shift-F2"),
                  ("shift-F3"  , "shift-F3"),
                  ("shift-F4"  , "shift-F4"),
                  ("shift-F5"  , "shift-F5"),
                  ("shift-F6"  , "shift-F6"),
                  ("shift-F7"  , "shift-F7"),
                  ("shift-F8"  , "shift-F8"),
                  ("shift-F9"  , "shift-F9"),
                  ("shift-F10" , "shift-F10"),
                  ("shift-F11" , "shift-F11"),
                  ("shift-F12" , "shift-F12"),                
                  ("ctrl-F1"  , "ctrl-F1"),
                  ("ctrl-F2"  , "ctrl-F2"),
                  ("ctrl-F3"  , "ctrl-F3"),
                  ("ctrl-F4"  , "ctrl-F4"),
                  ("ctrl-F5"  , "ctrl-F5"),
                  ("ctrl-F6"  , "ctrl-F6"),
                  ("ctrl-F7"  , "ctrl-F7"),
                  ("ctrl-F8"  , "ctrl-F8"),
                  ("ctrl-F9"  , "ctrl-F9"),
                  ("ctrl-F10" , "ctrl-F10"),
                  ("ctrl-F11" , "ctrl-F11"),
                  ("ctrl-F12" , "ctrl-F12"),
                  ("Alt-F1"  , "Alt-F1"),
                  ("Alt-F2"  , "Alt-F2"),
                  ("Alt-F3"  , "Alt-F3"),
                  ("Alt-F4"  , "Alt-F4"),
                  ("Alt-F5"  , "Alt-F5"),
                  ("Alt-F6"  , "Alt-F6"), 
                  ("Alt-F7"  , "Alt-F7"),
                  ("Alt-F8"  , "Alt-F8"),
                  ("Alt-F9"  , "Alt-F9"),
                  ("Alt-F10" , "Alt-F10"),
                  ("Alt-F11" , "Alt-F11"),
                  ("Alt-F12" , "ctrl-F12"),
                  ("ctrl-KP_Left", "open west"),
                  ("ctrl-KP_Right","open east"),
                  ("ctrl-KP_Up",   "open north"),
                  ("ctrl-KP_Down", "open south"),
                  ("ctrl-KP_Next", "open down"),                
                  ("ctrl-KP_Prior", "open up"),
                  ("ctrl-KP_End", "open down"),
                  ("Alt-KP_Left", "unlock west"),
                  ("Alt-KP_Right","unlock east"),
                  ("Alt-KP_Up",   "unlock north"),
                  ("Alt-KP_Down", "unlock south"),
                  ("Alt-KP_Next", "unlock down"),                
                  ("Alt-KP_Prior", "unlock up"),
                  ("Alt-KP_End", "unlock down"),
                  ("KP_Left", "west"),
                  ("KP_Right","east"),
                  ("KP_Up",   "north"),
                  ("KP_Down", "south"),
                  ("KP_Next", "down"),                
                  ("KP_Prior", "up"),
                  ("KP_End", "down"),
                  ("KP_Begin", "look"),
                  ("KP_Delete", "kp_delete"),
                  ("KP_Insert", "kp_insert"),
                  ("ctrl-KP_Delete", "ctrl_kp_delete"),
                  ("ctrl-KP_Insert", "ctrl_kp_insert"),
                  ("Alt-KP_Delete", "alt_kp_delete"),
                  ("Alt-KP_Insert", "alt_kp_insert"),

                  ("shift-Left", "west"),
                  ("shift-Right","east"),
                  ("shift-Up",   "north"),
                  ("shift-Down", "south"),
                  ("ctrl-Left", "open west"),
                  ("ctrl-Right","open east"),
                  ("ctrl-Up",   "open north"),
                  ("ctrl-Down", "open south"),
                  ("Escape", "escape"),

                  ("9","up",105),  
                  ("8","north",104),
                  ("7","look",103),
                  ("6","east",102),
                  ("4","west",100),
                  ("3","down",99),
                  ("2","south",98),
                  ("1","down",97),
		  ("ctrl-j","west"),
		  ("ctrl-k","east"),
		  ("ctrl-i","north"),
		  ("ctrl-b","down"),
		  ("ctrl-u","up"),
		  ("ctrl-n","south"),

		  ("ctrl-h","open west"),
		  ("ctrl-l","open east"),
		  ("ctrl-o","open north"),
		  ("ctrl-m","open south"),
		  ("ctrl-z","open up"),
		  ("ctrl-v","open down"),

                  #("ctrl+c" , command=self.copy_text)
                  
                  ]
               # under windows, Tk can't differentiate between numpad and non-numpad keys by the keysym. Therefore, a tuple
               # with three entries is used to define a *windows-only* key-binding which also checks for the keycode under
               # windows.

#from Tix import *
class GUI(Frame):
    def __init__(self, client, master):
        ##Toplevel.__init__(self,width=width)
        Frame.__init__(self, master)
        self.pack(side=TOP,expand = YES, fill=BOTH)
        self.client = client

        master.title("DMC")
        self.master = master
        #self.set_sizeoptions()
        self.var_disps=[]
        self.gauges = []
        self.affect_buttons=[]
        self.affect_button_active_fg="black"
        self.affect_button_active_bg="green"
        self.affect_button_fading_fg="black"
        self.affect_button_fading_bg="red"
        self.affect_button_inactive_fg="black"
        self.affect_button_inactive_bg="lightgrey"

        self.char_name = None
        self.transfer_focus = IntVar()
        self.last_command_stays = IntVar()
        self.show_statusbar = IntVar()
        self.triggers_on = IntVar()
        self.quiet = IntVar()
        self.quiet.set(0)
        self.triggers_on.set(1)
        self.transfer_focus.set(1)
        self.last_command_stays.set(1)
        self.show_statusbar.set(1)
        client.set_option("scrollsize",5)
        ## menue stuff

        menu=Menu(master)
        self.fontname = ("courier", 12, "bold")
        
        filemenu=Menu(menu)
        menu.add_cascade(label="File",menu=filemenu,underline=0)

        connectmenu = Menu(filemenu)
        filemenu.add_cascade(label="Connect...", menu = connectmenu,underline=0)
        
        connectmenu.add_command(label="Dawn of the Ages 8000",command=self.connect, underline=0)
        connectmenu.add_command(label="Dawn of the Ages 8080",command=self.connect2, underline=0)
        connectmenu.add_command(label="Dawn of the Ages 5190",command=self.connect3, underline=0)
        connectmenu.add_separator()
        connectmenu.add_command(label="Localhost",command=self.connect_localhost, underline=13)

        filemenu.add_separator()
        filemenu.add_command(label="disconnect",command=self.disconnect)
        filemenu.add_separator()
        filemenu.add_command(label="Load command file...",command=self.opencommand, underline=0)
        filemenu.add_command(label="Load python file...",command=self.openpython, underline=5)
        filemenu.add_separator()
        filemenu.add_command(label="Save",command=self.save_char, underline=0)
        self.save_index = filemenu.index(END)
        filemenu.entryconfigure(self.save_index, state = DISABLED)
        filemenu.add_command(label="Save as...",command=self.saveall, underline=5)
        filemenu.add_separator()
        exportmenu = Menu(filemenu)
        filemenu.add_cascade(label="Export...", menu = exportmenu,underline=0)
        
        exportmenu.add_command(label="Options...",command=self.saveoptions, underline=0)
        exportmenu.add_command(label="Aliases...",command=self.savealiases, underline=0)
        exportmenu.add_command(label="Triggers...",command=self.savetriggers, underline=0)
        exportmenu.add_command(label="Speedwalks...",command=self.savesw, underline=5)
        exportmenu.add_command(label="Buttons...",command=self.savebuttons, underline=0)
        exportmenu.add_command(label="Affects...",command=self.saveaffects, underline=1)
        exportmenu.add_command(label="all...",command=self.saveall, underline=0)

        filemenu.add_separator()
        index = filemenu.index(END)+1
        #filemenu.add_separator()
        self.file_index = index      # index of menu item after separator for char history
        self.filemenu = filemenu
        self.char_history = []       # chars displayed in menue
        
        filemenu.add_command(label="Exit",command=self.ask_quit,underline=1)
        #filemenu.add_command(label="Exit",command=self.mtest,underline=1)
        #filemenu.insert_command(index,label="TEST",command=self.mtest)
        self.testnr = 0

        
        editmenu=Menu(menu)
        menu.add_cascade(label="Edit",menu=editmenu,underline=0)
        editmenu.add_command(label="Copy",command=self.copy_text)
        #editmenu.add_command(label="Edit aliases...",command=self.show_aliases)
        editmenu.add_separator()
        editmenu.add_command(label="Edit aliases...",command=self.show_aliases, underline=5)
        editmenu.add_command(label="Edit triggers...",command=self.show_triggers, underline=5)
        editmenu.add_command(label="Edit speedwalks...",command=self.show_speedwalks, underline=5)
        #editmenu.add_command(label="Edit buttons...",command=self.show_buttons)
        
        editmenu.add_command(label="Edit Buttons...",command=self.add_spellbutton, underline=5)
        editmenu.add_command(label="Edit affects...",command=self.edit_affects, underline=6)
        
        settingsmenu=Menu(menu)
        menu.add_cascade(label="Settings",menu=settingsmenu,underline=0)
        settingsmenu.add_command(label="Preferences...",command=self.preferences,underline = 0)
        settingsmenu.add_command(label="Font...", command = self.fontsel,underline = 0)
        settingsmenu.add_command(label="Colors...", command = self.colorsel,underline = 0)
        
        settingsmenu.add_separator()
        settingsmenu.add_checkbutton(label="Triggers active", variable=self.triggers_on,underline = 0, command=self.toggle_trigger)
        settingsmenu.add_checkbutton(label="Transfer focus", variable=self.transfer_focus,underline = 9)
        settingsmenu.add_checkbutton(label="Suppress status messages", variable=self.quiet,underline = 23, command=self.toggle_quiet)
        settingsmenu.add_checkbutton(label="Last command stays", variable=self.last_command_stays,command = self.last_command_toggled,underline = 0)
        settingsmenu.add_checkbutton(label="Show statusbar", variable=self.show_statusbar,command = self.show_statusbar_toggled,underline = 0)
        
        
##        viewmenu=Menu(menu)
##        menu.add_cascade(label="View",menu=viewmenu)
##        viewmenu.add_command(label="Restore default view",command=self.default_windowpos)

        toolmenu=Menu(menu)
        menu.add_cascade(label="Tools", menu = toolmenu,underline=0)

        #toolmenu.add_command(label="xfontsel", command = self.xfontsel)

        toolmenu.add_command(label="Talker", command = self.talk,underline=0)
        toolmenu.add_command(label="Color Code Tool", command = self.ctool,underline=1)
        toolmenu.add_command(label="Affect display", command = self.show_affects, underline=0)
        
        toolmenu.add_separator()
        toolmenu.add_command(label="Add char", command = self.add_to_db)
        toolmenu.add_separator()
        
        composemenu=Menu(toolmenu)
        toolmenu.add_cascade(label="Compose...", menu = composemenu,underline=0)
        composemenu.add_command(label="note", command = self.compose_note,underline=0)
        composemenu.add_command(label="idea", command = self.compose_idea,underline=0)
        composemenu.add_command(label="scroll", command = self.compose_scroll,underline=0)
	composemenu.add_separator()
        composemenu.add_command(label="verbatim", command = self.verb_create,underline=0)

        #menu.add_separator()

        helpmenu = Menu(menu)

        helpmenu.add_command(label="documentation", command = self.help_docs,underline=0)
        helpmenu.add_separator()
        helpmenu.add_command(label="about DMC", command = self.help_about,underline=0)
        menu.add_cascade(label="Help", menu=helpmenu,underline=0)

        master.configure(menu=menu)
        master.protocol("WM_DELETE_WINDOW", self.ask_quit)

        # widgets
        mainframe = Frame(self)
        
        term = Term.TermWindow(mainframe)

        self.term = term        
	self.entryf = Frame(mainframe)
        #self.entry = Term.HistoryEntry(mainframe,output=self.client.output,toscroll=self.term.text,client=self.client)
	self.entry = Term.HistoryEntry(self.entryf,output=self.client.output,toscroll=self.term.text,client=self.client)
        #self.entry.configure(background="black")
        self.entry.set_enterfun(self.enter_fun)

        self.status = Canvas(mainframe,height=46,background="black") #=mainframe["background"])
        self.bind_all("<KeyPress Scroll_Lock>",term.toggle_scroll_lock)
        self.bind_all("<Control-KeyPress s>",term.toggle_scroll_lock) 
       
        self.minimap = MiniMap(self.status, self, 0, 0, 46)
        
        self.hpgauge = Gauge(self.status, self, 50, 2, 200)
        self.hptankgauge = Gauge(self.status, self, 50, 16, 200)
        self.hpfoegauge = Gauge(self.status, self, 50, 30, 200)
        self.managauge = Gauge(self.status, self, 296, 2, 140)
        self.movegauge = Gauge(self.status, self, 480, 2, 140)
        self.gauges.append(self.hpgauge)
        self.gauges.append(self.hptankgauge)
        self.gauges.append(self.hpfoegauge)
        self.gauges.append(self.managauge)
        self.gauges.append(self.movegauge)

        

        self.var_disps.append(VarDisp(self.status, self, 300, 17, "","tank_name"))

        box = VarDisp(self.status, self, 408, 17, "G: ","gold","#FFFF00")
        box.set(9999)
        (x1,y1,x2,y2)=self.status.bbox(box.text)
        box.set(None)
        self.var_disps.append(box)

        box = VarDisp(self.status, self, x2+10, 17, "S: ","silver","#FFFFFF")
        box.set(99999)
        (x1,y1,x2,y2)=self.status.bbox(box.text)
        box.set(None)
        self.var_disps.append(box)

        box = VarDisp(self.status, self, x2+10, 17, "Q: ","qp","#FF00FF")
        box.set(99999)
        (x1,y1,x2,y2)=self.status.bbox(box.text)
        box.set(None)
        self.var_disps.append(box)

        
        box = VarDisp(self.status, self, x2+10, 17, "tnl: ","tnl")
        box.set(99999)
        (x1,y1,x2,y2)=self.status.bbox(box.text)
        box.set(None)
        self.var_disps.append(box)

        
        self.var_disps.append(VarDisp(self.status, self, 300, 31, "","foe_name"))
        self.var_disps.append(VarDisp(self.status, self, 408, 31, "","room_name"))
        
        self.aff_win = Term.TermWindow(mainframe, width=80, height= 1, scrollbar=0)
        self.aff_win_height = 1
        self.aff_win.append(" ")
        
        term.pack(side=TOP,expand=YES,fill=BOTH)        
        self.status.pack(side=TOP,fill=X)
        self.aff_win.pack(side=TOP, fill=X)
        
#	self.entry.pack(side=BOTTOM,expand=NO,fill=X)
#	self.entryf.pack(side=LEFT,expand=YES,fill=X)
	self.entry.pack(side=LEFT,expand=YES,fill=X)
	self.entryf.pack(side=BOTTOM,expand=NO,fill=X)

	Label(self.entryf, text="   ").pack(expand=NO, fill= None, side=LEFT)


        mainframe.pack(side=LEFT,fill=BOTH,expand=YES)

        sideframe = Frame(self)
        sideframe.pack(side=LEFT,fill=Y)
        self.sideframe = sideframe
        
        spellframe = Frame(sideframe)
        spellframe.configure(relief=SUNKEN,borderwidth=2)

        spellframe.pack(side=TOP)
        self.spellframe = spellframe

        buttonframe = Frame(sideframe)
        buttonframe.configure(relief=SUNKEN,borderwidth=2)
        buttonframe.pack(side=TOP)

        self.setfont(self.fontname)
        self.set_sizeoptions()
        self.master.bind("<ButtonRelease-1>", self.maybe_focus_entry)
        self.entry.bind("<Control-KeyPress-p>",self.entry.c_up)
        self.default_keybindings()
        self.read_char_history()
        

    def read_char_history(self):
        try:
            f = open(".dmc_charhistory","r")
            cl = f.readlines()
            cl.reverse()
            for l in cl:
                self.add_char(l.strip(),None)
            close(f)
        except:
            pass
        
    def add_char(self, charname,save_history = 1):
        """ add charname to the file menue """
        n = len (self.char_history)
        nitems = 16
        if n==0:
            self.filemenu.insert_separator(self.file_index)
            
        if charname in self.char_history:
            pos = self.char_history.index(charname)
            self.char_history[pos]= self.char_history[0]
            self.char_history[0]=charname
            for i in range(len(self.char_history)):
                self.filemenu.entryconfigure(self.file_index+i,label=self.char_history[i],
                                             command = lambda c=self.char_history[i],s=self: s.char_clicked(c))

        elif n<nitems:    
            self.filemenu.insert_command(self.file_index,label=charname,
                                         command = lambda c=charname,s=self: s.char_clicked(c))
            self.char_history.insert(-1,charname)
        else:
            self.char_history.insert(-1,charname)
            self.char_history = self.char_history[:nitems]
            for i in range(4):
                self.filemenu.entryconfigure(self.file_index+i,label=self.char_history[i],
                                             command = lambda c=self.char_history[i],s=self: s.char_clicked(c))

        if save_history:
            f = open(".dmc_charhistory","w")
            for c in self.char_history:
                f.write("%s\n" % c)
            f.close()
                
    def char_clicked(self,name):
        #print "clicked on:%s<=" % name
        self.add_char(name)
        
        if self.client.chardb.has_key(name):
            e = self.client.chardb[name]
            self.client.read_file(e.pname+".cmd")
            self.char_name = e.pname
            self.master.title(e.dname)
            self.client.title=e.dname
            self.filemenu.entryconfigure(self.save_index, state = ACTIVE)
            self.client.do_connect(e.pname, e.pw)
            #print "connecting %s (%s) using password %s" % (e.pname, e.dname, e.pw)

    def add_to_db(self):
        reload(Tool)
        Tool.AddToDb(self,self.client)
        
        
    def mtest(self):
        #self.filemenu.entryconfigure(self.test_index,label="TEST%s" % self.testnr)
        #self.testnr = self.testnr + 1
        n = random.choice(range(6))
        print "adding " , n
        self.add_char(("char nr %s." % n))


    def set_options(self):
        """set all variables as options in client"""
        self.set_sizeoptions()
        client = self.client
        client.set_option("transfer_focus",    self.transfer_focus.get())
        client.set_option("last_command_stays",self.last_command_stays.get())
        client.set_option("show_statusbar",    self.show_statusbar.get())
        client.set_option("triggers_on",       self.triggers_on.get())
        client.set_option("quiet",             self.quiet.get())
        

    def use_options(self):
        """set all variables from options in client"""

        client = self.client
        self.transfer_focus.set(client.get_ioption("transfer_focus"))
        self.last_command_stays.set(client.get_ioption("last_command_stays"))
        self.show_statusbar.set(client.get_ioption("show_statusbar"))
        self.triggers_on.set(client.get_ioption("triggers_on"))
        self.quiet.set(client.get_ioption("quiet"))

        self.show_statusbar_toggled()
        self.last_command_toggled()
        self.toggle_trigger()
        self.default_windowpos()
        
    def set_sizeoptions(self):
        m=re.compile("(\d*)x(\d*)\+(\d*)\+(\d*)")
        #g = m.match(self.master.winfo_geometry())
        #print "set_sizeoptions:",g.groups()
        g = m.match(self.master.geometry())
        #print "set_sizeoptions:",g.groups()
        if g:
            (guiwidth,guiheight,guix,guiy)=g.groups()
            self.client.set_option("menu x",guix)
            self.client.set_option("menu y",guiy)
            self.client.set_option("menu width",guiwidth)
            self.client.set_option("menu height",guiheight)

    def show_statusbar_toggled(self):
        if self.show_statusbar.get():
            self.status.pack(fill=X)
            self.aff_win.pack(side=TOP, fill=X)
        else:
            self.status.pack_forget()
            self.aff_win.pack_forget()
            
    def last_command_toggled(self):
        self.entry.last_stays = self.last_command_stays.get()


    def toggle_trigger(self):
        self.client.triggers_on = self.triggers_on.get()

    def toggle_quiet(self):
        self.client.set_option("quiet", self.quiet.get())

    def maybe_focus_entry(self, event):
	if self.transfer_focus.get():
           self.focus_entry()
           
    def focus_entry(self):
        self.entry.focus_set()

    def default_keybindings(self):
        for b in def_key_bindings:
            if len(b)<3:
                self.client.defkey(b[0],b[1])
            else:
                self.client.defkey(b[0],b[1],b[2])
    
    def copy_text(self):
        try:
            text = self.term.text.selection_get()
            self.clipboard_clear()
            self.clipboard_append(text)
        except:
            pass

    def talk(self):
        name = askstring("Talk to", "Name of the player to talk to:")
        if name and len(name)>0:
            t = Talk.Talker(self.client, name)

    def show_affects(self):
        self.client.add_win(Term.TermOutput(self.client, "affects", "Affects", 50, 15,transient=1))

    def ctool(self):
        reload(Tool)
        Tool.ColorTool(self)
        
    def xfontsel(self):
        f = os.popen("xfontsel -print", "r")
        erg = f.readline()
        f.close()
        print "font:",erg
        
        self.term.set_font(erg)

    def colorsel(self):
        reload(Tool)
        Tool.ColorEditor(self,"Config colors",self.client)
        
    def fontsel(self):
        reload(Tool)
        Tool.FontSelector(self)

    def setfont(self, font):
        self.term.set_font(font)
        self.entry.configure(font=font)
        self.fontname = font
        self.aff_win.set_font(font)
        for d in self.var_disps:
            d.setfont(font)
        for g in self.gauges:
            g.setfont(font)

        for win in self.client.windows.values():
            win.set_font(font)

            
    def output(self, text):
        self.term.append(text)


    def enter_fun(self, text):
        self.client.process_command(text)

    def insert_entry(self, text):
        """ insert text at current curser position in the entry line """
        self.entry.insert(CURRENT,text)
        

    def ask_quit(self):
        erg = askquestion("Quit ?", "Do you really want to quit ?")
        if erg=="yes":
            self.do_exit()
            
    def do_exit(self):
        self.master.quit()

    def configterminal(self,event=None):
        ConfigTermDialog(gui)
        
    def on_close(self):
        global gui
        gui=None
        self.master.withdraw()

    def connect(self):
        self.client.process_command("#connect")

    def connect2(self):
        self.client.process_command("#connect rplay.net 8080")

    def connect3(self):
        self.client.process_command("#connect rplay.net 5190")

    def disconnect(self):
        self.client.process_command("#disconnect")
        
    def connect_localhost(self):
        self.client.process_command("#connect localhost")
        
    def write_colors(self, file):
        for c in Term.colors:
            file.write("#color %s~%s\n#color bright %s~%s\n"%(c,Term.rgb[c],c,Term.brgb[c]))
        file.write("#color foreground~%s\n#color background~%s\n"%(self.term.text.tag_cget("normal","foreground"),self.term.text.tag_cget("normal","background")))
        file.write("#buttoncolor active foreground %s\n"%self.affect_button_active_fg)
        file.write("#buttoncolor active background %s\n"%self.affect_button_active_bg)
        file.write("#buttoncolor inactive foreground %s\n"%self.affect_button_inactive_fg)
        file.write("#buttoncolor inactive background %s\n"%self.affect_button_inactive_bg)
        file.write("#buttoncolor fading foreground %s\n"%self.affect_button_fading_fg)
        file.write("#buttoncolor fading background %s\n"%self.affect_button_fading_bg)
    
    def set_color(self,name,value):
        if name == "foreground":
            self.term.text.tag_configure("normal",foreground=value)
        else:
            if name == "background":
                self.term.text.tag_configure("normal",background=value)
                self.term.text.configure(background=value)
                self.status.configure(background=value)
                self.aff_win.text.configure(background=value)
                #self.entry.configure(background=value)
                text = self.term.text
                for c in Term.colors:
                    text.tag_configure(c,foreground=Term.rgb[c],background=value)
                    text.tag_configure("b"+c,foreground=Term.brgb[c],background=value)
                    text.tag_configure("v"+c,background=Term.rgb[c],foreground=value)
                    text.tag_configure("vb"+c,background=Term.brgb[c],foreground=value)
            else:
                if name[:7] == "bright ":
                    c = name[7:]
                    Term.brgb[c] = value
                    text = self.term.text
                    text.tag_configure(c,foreground=Term.rgb[c])
                    text.tag_configure("b"+c,foreground=Term.brgb[c])
                    text.tag_configure("v"+c,background=Term.rgb[c])
                    text.tag_configure("vb"+c,background=Term.brgb[c])
                else:
                    c = name
                    Term.rgb[c] = value
                    text = self.term.text
                    text.tag_configure(c,foreground=Term.rgb[c])
                    text.tag_configure("b"+c,foreground=Term.brgb[c])
                    text.tag_configure("v"+c,background=Term.rgb[c])
                    text.tag_configure("vb"+c,background=Term.brgb[c])
            
                
    def default_windowpos(self,event=None):
        #global buttons
        
        geometry="%dx%d%+d%+d" % (int(self.client.options["menu width"]),int(self.client.options["menu height"]),int(self.client.options["menu x"]),int(self.client.options["menu y"]))
        self.master.geometry(geometry)
        #for b in buttons.hash.keys():
        #    buttons.hash[b].button.pack(side=custom_orient)
        
    def opencommand(self):
        name=askopenfilename(filetypes=(("Command files","*.cmd"),("Alias files","*.als"),("Triggers files","*.trg"),("Speedwalks files","*.spw"),("Options files","*.opt"),("Button files","*.btn"),("Affects files","*.aff"),("All files","*.*")))
        if name:
            self.client.read_file(name)

    def openpython(self):
        name=askopenfilename(filetypes=(("Python files","*.py"),("All files","*")))
        if name:
            self.client.load_file(name)

    def saveoptions(self):
        name=asksaveasfilename(filetypes=(("Options files","*.opt"),("Command files","*.cmd"),("All files","*")))
        if name:
            self.client.write_options(name)
            
    
    def savealiases(self):
        name=asksaveasfilename(filetypes=(("Alias files","*.als"),("Command files","*.cmd"),("All files","*")))
        if name:
            self.client.write_aliases(name)

    def saveaffects(self):
        name=asksaveasfilename(filetypes=(("Affect files","*.aff"),("Command files","*.cmd"),("All files","*")))
        if name:
            self.client.write_affects(name)
         
    def savetriggers(self):
        name=asksaveasfilename(filetypes=(("Triggers files","*.trg"),("Command files","*.cmd"),("All files","*")))
        if name:
            self.client.write_triggers(name)

    def savesw(self):
        name=asksaveasfilename(filetypes=(("Speedwalks file","*.spw"),("Command files","*.cmd"),("All files","*")))
        if name:
            self.client.write_speedwalks(name)
    def savebuttons(self):
        name=asksaveasfilename(filetypes=(("Buttons file","*.btn"),("Command files","*.cmd"),("All files","*")))
        if name:
            self.client.write_buttons(name)

    def save_char(self):
        if self.char_name:
            self.client.write_file(self.char_name+".cmd")
            
    def saveall(self):
        name=asksaveasfilename(filetypes=(("Command files","*.cmd"),("All files","*")))
        if name:
            self.client.write_file(name)
    
    def preferences(self):
        reload(Tool)
        Tool.PreferenceDialog(self,"Preferences",self.client)

    def edit_affects(self):
        reload(Tool)
        Tool.AffectEditor(self,self.client)
    
    def show_aliases(self):
        reload(Tool)
        Tool.HashDialog(self, self.client.aliases, "Alias","Aliases")
       

    def show_triggers(self):
        reload(Tool)
        Tool.TriggersDialog(self, "Triggers", self.client)
       
    def show_speedwalks(self):
        reload(Tool)
        Tool.HashDialog(self, self.client.speedwalks,"Speedwalk","Speedwalks")

##     def show_buttons(self):
##         reload(Tool)
##         Tool.ButtonsDialog(self, self.client, "Button","Buttons")

    def verb_create(self):
        reload(Verbcreator)
        c = Verbcreator.Verbcreator(self.client)	

    def compose_note(self):
        reload(Composer)
        c = Composer.MsgComposer(self.client, "note")
        
    def compose_idea(self):
        reload(Composer)
        c = Composer.MsgComposer(self.client, "idea")

    def compose_scroll(self):
        reload(Composer)
        c = Composer.MsgComposerScroll(self.client)


    def color_buttons(self):
        """Set the color of the buttons depending on the active spell affects """
        actives = self.client.get_actives() 
        fadings = self.client.get_fadings()
        for button in self.affect_buttons:
            name = button.name
            if actives.has_key(name):
                if fadings.has_key(name):
                    button.configure(foreground=self.affect_button_fading_fg,background=self.affect_button_fading_bg)
                else:
                    button.configure(foreground=self.affect_button_active_fg,background=self.affect_button_active_bg)
            elif self.client.get_affects().has_key(name):
                button.configure(foreground=self.affect_button_inactive_fg,background=self.affect_button_inactive_bg)

                

    def notify_input(self):
        """this is called by Client, after input has been recieved
        (that usually means the whole prompt, so all variables should
        be up to date for display in the gauges)
        """
        try:
            self.color_buttons()
            
            client = self.client
            self.hpgauge.set_val(client.get_var("hp"), client.get_var("max_hp"))
            self.managauge.set_val(client.get_var("mana"), client.get_var("max_mana"))
            self.movegauge.set_val(client.get_var("move"), client.get_var("max_move"))
            self.hptankgauge.set_val(client.get_var("tank"), 100)
            self.hpfoegauge.set_val(client.get_var("foe"), 100)
            self.minimap.set_val(client.get_var("exits"))
            
            for vd in self.var_disps:
                vd.set(client.get_var(vd.var_name))
            #print "w:",self.status.bbox(vd.text)

            # redisplay affects on char
            self.aff_win.clear()
            self.aff_win.append(client.render_affects())

            # back text in terminal (without color codes)
            text = self.aff_win.text.get(1.0,END)

            if len(text)>80:            # adjust terminal size, if neccessary 
                if self.aff_win_height==1:
                    self.aff_win.text.configure(height=2)
                    self.aff_win_height = 2
            else:
                if self.aff_win_height ==2:
                    self.aff_win.text.configure(height=1)
                    self.aff_win_height = 1
        except:
            pass
        
    def create_spellframe(self):
        if not self.spellframe:
                spellframe = Frame(self.sideframe)
                spellframe.configure(relief=SUNKEN,borderwidth=2)
            
                spellframe.pack(side=TOP)
                self.spellframe = spellframe
            
    def remove_empty_spellframe(self):
        if self.spellframe:
            if len(self.spellframe.children)==0:
                self.spellframe.destroy()
                
    def add_spellbutton(self):
        reload(Tool)
        self.max_mana = 0
        Tool.SpellButtonEditor(self.client, self)

    def create_affect_button(self, name, action):
        self.create_spellframe()
        b = SpellButton(self.spellframe, self.client, name, action)
        b.pack(side=TOP,fill=X)
        self.affect_buttons.append(b)
       
    def remove_affect_button(self, name):
        for b in self.affect_buttons:
            if b.name==name:
                b.destroy()
                self.affect_buttons.remove(b)
        if (len(self.affect_buttons) == 0):
            self.spellframe.destroy()

    def clear_affect_buttons(self):
        #remove all spellbuttons and the spellframe
        for b in self.affect_buttons:
            b.destroy()
        self.affect_buttons=[]
        self.spellframe.destroy()
        self.spellframe=None
        
    def help_about(self):
        showinfo("About DMC",
"""DMC the official Client of
Dawn of the Ages
http://dawn.rplay.net

Copyright (C) 2002  P. Herth

Version: 1.0 beta 6""")


    def help_docs(self):
        f = open("DOCS","r")
        l = f.readlines()
        f.close()
        d = string.join(l,"")
        TextMsg(self,"DMC Documentation",d)
        
            
class TextMsg(Toplevel):
    def __init__(self,  gui, title, msg):
        Toplevel.__init__(self)
        self.title(title)
        self.gui = gui
        self.transient(gui)
        
        text = Text(self,width=80)
        sb = Scrollbar(self, command = text.yview)
        text.configure(yscrollcommand=sb.set)
        text.pack(side=LEFT,fill=BOTH,expand=YES)
        sb.pack(side=RIGHT,fill=Y,expand=NO)

        

        text.insert(END,msg)
        text.configure(state=DISABLED)

class ConfigTermDialog(Dialog):
    def body(self, master):
        self.fontopts=Frame(master)
        self.scrollbar = Scrollbar(self, orient=VERTICAL)
        self.list=Listbox(self.fontopts,exportselection=0,yscrollcommand=self.scrollbar.set)
        self.scrollbar.config(command=self.list.yview)
        self.list.grid(row=0,column=0,sticky=S+N+E+W)
        self.scrollbar.grid(row=0,column=1,sticky=S+N)
	self.list.bind("<Button-1>", self.list_has_changed)
        self.list.bind("<B1-Motion>",self.list_ignore)
        self.list.bind("<Double-Button-1>",self.list_ignore)
        self.list.bind("<ButtonRelease-1>",self.list_ignore)
        self.demofield=Text(self.fontopts,height=2)
        self.demofield.tag_config("f",font=termfont)
        self.demofield.insert(END,"ABCDE abcde XYZ xyz","f")
        self.demofield.grid(row=1,column=0)
        fams=[]
        for f in tkFont.families():
            fams.append(f)
        fams.sort()
        for f in fams:
            self.list.insert(END,f)
        self.list.activate(0)
        self.list.select_clear(0,END)
        self.list.select_set(0)
        self.fontopts.grid(row=0,column=0)
       
        
    def list_has_changed(self,event=None):
        self.list.activate(self.list.nearest(event.y))
        termfont=(self.list.get(ACTIVE),termfontsize)
        self.demofield.tag_config("f",font=termfont)
        self.demofield.configure(height=2)
        return
    
    def list_ignore(self,event=None):
        return
    

class SpellButton(Button):
    def __init__(self, master, client, name, command):
        Button.__init__(self, master,text=name)
        self.name = name
        self.client = client
        self.command = command
        self.configure(command=self.do_command)

    def do_command(self):
        self.client.process_command(self.command)


class VarDisp:
    """ class used to display the content of a variable in the status canvas"""
    def __init__(self, canvas, gui, x, y, label, var_name, color="lightgray"): 
        self.x=x
        self.y=y
        self.canvas = canvas
        self.gui = gui
        self.var_name = var_name
        self.color = color
        self.label = label
        self.text = canvas.create_text(self.x, self.y, text="",fill=color,
                                       font=gui.fontname,anchor=NW)

    def setfont(self, font):
        self.canvas.itemconfig(self.text,font = font)

    def set_text(self, txt):
        if txt!=None:
            self.canvas.itemconfigure(self.text,text=txt)
        else:
            self.canvas.itemconfigure(self.text,text="")
        
    def set(self, txt):
        if txt!=None:
            self.canvas.itemconfigure(self.text,text=self.label+"%s"%txt)
        else:
            self.canvas.itemconfigure(self.text,text="")


class Gauge:
    def __init__(self, canvas, gui, x, y, width):
        self.val = None
        self.max = None
        self.x=x
        self.y=y
        self.width=width
        self.height = gui.fontname[1]

        self.y2 = self.y+self.height

        self.x2 = self.x
        self.gui = gui
        self.canvas = canvas
        self.rectangle = canvas.create_rectangle(self.x,self.y,self.x2,self.y2,fill="green")
        t = canvas.create_text(self.x+self.width, self.y, text="   ",fill="lightgray",
                               font=gui.fontname,anchor=NW)
        self.text = t

    def setfont(self, font):
        self.canvas.itemconfig(self.text,font = font)

    def valcolor(self, percent):
        if percent < 25:
            return "#FF0000"
        elif percent < 50:
            return "#FFFF00"
        elif percent < 75:
            return "#00C000"
        else:
            return "#00FF00"

    def coords(self, *args):
        self.canvas.tk.call((self.canvas._w, 'coords') + args)    

    def set_val(self, val, max):
        percent =0
        color = None
        try:            
            if val == None:
                #self.canvas.coords(self.rectangle,self.x,self.y+1,self.x+1,self.y2-1)
		self.coords(self.rectangle,self.x,self.y+1,self.x+1,self.y2-1)	
                self.canvas.itemconfigure(self.text,text="    ")
                return
            if max == None:         
                self.coords(self.rectangle,self.x,self.y+1,self.x+1,self.y2-1)
                self.canvas.itemconfigure(self.text,text="    ")
                return
            if max == 0:
                self.coords(self.rectangle,self.x,self.y+1,self.x+1,self.y2-1)
                self.canvas.itemconfigure(self.text,text="    ")
                return

            self.val = val
            self.max = max

            if self.val and self.max and self.max > 0:
                percent = 100*self.val/self.max
                self.x2 = self.x+(self.width*self.val/self.max)
                color = self.valcolor(percent)
                self.coords(self.rectangle,self.x,self.y+1,self.x2,self.y2-1)
                self.canvas.itemconfigure(self.rectangle,fill=color)
                self.canvas.itemconfigure(self.text,text="%4d"%self.val)
            else:
                self.coords(self.rectangle,self.x,self.y+1,self.x,self.y2-1)
                self.canvas.itemconfigure(self.text,text="    ")
               
        except:
            msg ="'Error occured during display of gauges:"
            for s in traceback.format_exception(sys.exc_type, sys.exc_value, sys.exc_traceback):
                msg=msg+"\n"+string.rstrip(s)
            msg = msg + "\n" + "self.val = %s (%s)" % (self.val, type(self.val))
            msg = msg + "\n" + "self.max = %s (%s)" % (self.max, type(self.max))
            
            msg = msg + "\n" + "self.x1 = %s (%s)" % (self.x, type(self.x))
            msg = msg + "\n" + "self.x2 = %s (%s)" % (self.x2, type(self.x2))
            msg = msg + "\n" + "self.y1 = %s (%s)" % (self.y, type(self.y))
            msg = msg + "\n" + "self.y2 = %s (%s)" % (self.y2, type(self.y2))
            msg = msg + "\n" + "percent = %s (%s)" % (percent, type(percent))
            msg = msg + "\n" + "color = %s (%s)" % (color, type(color))
            print msg
            self.gui.clipboard_clear()
            self.gui.clipboard_append(msg)
            msg = msg + "\n(this message has been copied to the clipboard)"
            showinfo("An error occurred:", msg)
            
class MiniMap:
    def __init__(self, canvas, gui, x, y, size):
        self.canvas = canvas
        self.gui = gui
        self.x = x
        self.y = y
        self.size = size
        self.r = canvas.create_rectangle(x,y, x+size, y+size, outline="lightgray",fill="lightgray")

        self.n = None
        self.e = None
        self.w = None
        self.s = None
        self.u = None
        self.d = None

        w = 6
        self.dicker_punkt = canvas.create_oval(x+size/2-w,y+size/2-w,x+size/2+w,y+size/2+w,fill="red")

        x = self.x+self.size/2
        y = self.y+self.size/2
        l = self.size/2
        self.n = canvas.create_line(x,y,x,y,arrow=LAST, width=3)
        self.e = canvas.create_line(x,y,x,y,arrow=LAST, width=3)
        self.s = canvas.create_line(x,y,x,y,arrow=LAST, width=3)
        self.w = canvas.create_line(x,y,x,y,arrow=LAST, width=3)
        self.u = canvas.create_line(x,y,x,y,arrow=LAST, width=3)
        self.d = canvas.create_line(x,y,x,y,arrow=LAST, width=3)
        
        canvas.lift(self.dicker_punkt)
        
        

        #self.set_val("NES")

    def coords(self, *args):
        self.canvas.tk.call((self.canvas._w, 'coords') + args)    
        
    def set_val(self, exits):
        canvas = self.canvas
        x = self.x+self.size/2
        y = self.y+self.size/2
        l = self.size/2

        if not exits:
            return
        
        if string.find(exits,"N")>=0:
            self.coords(self.n,x,y,x,y-l)
##            if not self.n:
##                self.n = canvas.create_line(x,y,x,y-l,arrow=LAST, width=3)
        else:
            self.coords(self.n,x,y,x,y)
##            if self.n:
##                canvas.delete(self.n)
##                self.n = None
                
        if string.find(exits,"E")>=0:
            self.coords(self.e, x,y,x+l,y)
##            if not self.e:
##                self.e = canvas.create_line(x,y,x+l,y,arrow=LAST, width=3)
        else:
            self.coords(self.e, x,y,x,y)
##            if self.e:
##                canvas.delete(self.e)
##                self.e = None
                
        if string.find(exits,"S")>=0:
            self.coords(self.s,x,y,x,y+l)
##            if not self.s:
##                self.s = canvas.create_line(x,y,x,y+l,arrow=LAST, width=3)
        else:
            self.coords(self.s,x,y,x,y)
##            if self.s:
##                canvas.delete(self.s)
##                self.s = None
                
        if string.find(exits,"W")>=0:
            self.coords(self.w,x,y,x-l,y)
##            if not self.w:
##                self.w = canvas.create_line(x,y,x-l,y,arrow=LAST, width=3)
        else:
            self.coords(self.w,x,y,x,y)
##            if self.w:
##                canvas.delete(self.w)
##                self.w = None
                
        if string.find(exits,"U")>=0:
            self.coords(self.u, x,y,x+l-2-4,y-l+2)
##            if not self.u:
##                self.u = canvas.create_line(x,y,x+l-2-4,y-l+2,arrow=LAST, width=3)
        else:
            self.coords(self.u, x,y,x,y)
##            if self.u:
##                canvas.delete(self.u)
##                self.u = None
                
        if string.find(exits,"D")>=0:
            self.coords(self.d, x,y,x-l+2+4,y+l-2)
##            if not self.d:
##                self.d = canvas.create_line(x,y,x-l+2+4,y+l-2,arrow=LAST, width=3)
        else:
            self.coords(self.d, x,y,x,y)
##            if self.d:
##                canvas.delete(self.d)
##                self.d = None

        canvas.lift(self.dicker_punkt)
