#  A mud client for
#  Dawn of the Ages  http://dawn.rplay.net
#
#  Copyright (C) 2001,2002 Peter Herth <p.herth@uni-koeln.de>
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

from Tkinter import *
from string import *
from Utilities import *
import re

# color code number definition (0-7)
(BLACK,RED,GREEN,YELLOW,BLUE,MAGENTA,CYAN,WHITE)=range(8)

rgb = { "black":  "#000000",
        "red":    "#C00000",
        "green":  "#00C000",
        "yellow": "#C0C000",
        "blue":   "#0000C0",
        "magenta":"#C000C0",
        "cyan":   "#00C0C0",
        "white":  "#C0C0C0"}

brgb ={"black":  "#606060",
       "red":    "#FF0000",
       "green":  "#00FF00",
       "yellow": "#FFFF00",
       "blue":   "#0000FF",
       "magenta":"#FF00FF",
       "cyan":   "#00FFFF",
       "white":  "#FFFFFF"}


colors = [ "black",
           "red",
           "green",
           "yellow",
           "blue",
           "magenta",
           "cyan",
           "white"]







class TermWindow(Frame):
    def __init__(self, master, width=80, height=25,scrollbar = 1):
        Frame.__init__(self, master)
        self.scroll_lock=0
        text = Text(self,height=1, width=1)
        self.text = text
        text.pack(side=LEFT,fill=BOTH,expand=YES)
        sld=Label(self,text="(scroll lock)")
        sld.place(relx=1.0,rely=1.0,anchor=SE,in_=self.text)
        self.scroll_lock_display=sld
        self.scroll_lock_display.lower(self.text)
        if scrollbar:
            self.sb = Scrollbar(self, command = self.text.yview)
            text.configure(yscrollcommand=self.sb.set)

            self.sb.pack(side=RIGHT,fill=Y,expand=NO)

        #text.configure(selectbackground="gray")
        
        text.tag_configure("normal", foreground=rgb["white"], background=rgb["black"])
        
        for c in colors:
            text.tag_configure(c,foreground=rgb[c],background=rgb["black"])
            text.tag_configure("b"+c,foreground=brgb[c],background=rgb["black"])
            text.tag_configure("v"+c,background=rgb[c],foreground=rgb["black"])
            text.tag_configure("vb"+c,background=brgb[c],foreground=rgb["black"])
            text.tag_configure("u"+c,foreground=rgb[c],background=rgb["black"],underline=1)
            text.tag_configure("ub"+c,foreground=brgb[c],background=rgb["black"],underline=1)
            text.tag_configure("uv"+c,background=rgb[c],foreground=rgb["black"],underline=1)
            text.tag_configure("uvb"+c,background=brgb[c],foreground=rgb["black"],underline=1)


        
        text.configure(background= "black")
        text.configure(foreground= "#A0A0A0")
        
        #text.configure(font=(("adobe", "courier" ,"normal"),14))
        text.configure(font=("-adobe-courier-bold-r-normal-*-17-120-100-100-m-100-iso8859-*",14))
        
        text.configure(wrap=CHAR)
        text.configure(width=width)
        text.configure(height=height)

        self.state = ColorState()
        self.smileys={}
        
	try:	
	    self.photo = PhotoImage(file="smiley.gif")
            #self.as("*dawnoftheages*","dawn.gif")
            self.asImage(":)","smiley.gif")
            self.asImage(">:|","angry.gif")
            self.asImage(":n8t","nacht.gif")
            self.asImage(":==)","heuldoch.gif")
            self.asImage(":]","biggrin.gif")
            self.asImage("8-)","cool.gif")
            self.asImage(":)","smiley.gif")
            self.asImage(":(","sad.gif")
            self.asImage(":O","shocked.gif")
            self.asImage(":p","tongue.gif")
            self.asImage(";)","wink.gif")
            self.do_smileys = 1
	except:
	    print "cannot load smiley.gif"
	    self.photo = None
        #print "photo:",self.photo

        text.tag_raise("sel")

        self.ansi_re = re.compile("\033\[([0-9;]*m)")
        
    def asImage(self, token, f):
        try:
            photo = PhotoImage(file=f)
            self.smileys[token]=photo
        except:
            print "cannot load",f
            pass
        
    def toggle_scroll_lock(self, event=None):
        self.scroll_lock = not self.scroll_lock
        if self.scroll_lock:
            self.scroll_lock_display.lift()
        else:
            self.scroll_lock_display.lower()
        #print self.scroll_lock
        
    def set_font(self, name):
        self.text.configure(font=(name))

    def append_tag(self, text, tag):
        if self.photo:
            p2 = find(text,":)")
            while (p2 >=0):
                if (p2 > 0):
                    self.text.insert(END, text[:p2], self.state.getTag())
	   
                self.text.image_create(END, image=self.photo)
                text = text[p2+2:]
                p2 = find(text,":)")
            
        self.text.insert(END, text, self.state.getTag())

    def append_tags(self, text, tag):
        if self.do_smileys:
            for token in self.smileys.keys():
            
                p2 = find(text,token)
                while (p2 >=0):
                    if (p2 > 0):
                        #self.text.insert(END, text[:p2], self.state.getTag())
                        self.append_tags(text[:p2], tag)
	   
                    self.text.image_create(END, image=self.smileys[token])
                    text = text[p2+len(token):]
                    p2 = find(text,token)
            
        self.text.insert(END, text, tag)


    def append(self, text):
        text= replace(text,"\r", "")
        pos = find(text,"\33")
        while pos >= 0:
            if pos > 0:
                part = text[:pos]

                #self.text.insert(END, part, self.state.getTag())
                self.append_tags(part, self.state.getTag())
                text = text[pos+1:]
            else:
                text = text[1:]
            #change state
            text = self.state.change(text)
            pos = find(text,"\33")                       

        #self.text.insert(END, text, self.state.getTag())
        self.append_tags(text, self.state.getTag())
    
        
##        parts = split(text,"\33")
##        for part in parts:
        
##            self.text.insert(END,part)
        if not self.scroll_lock:
            self.text.see(END)

            
    def append_new(self, text):
        text= replace(text,"\r", "")
        parts = re.split(self.ansi_re,text)
        
        texts = []
        tags = []

        tags.append(self.state.getTag())

        #self.text.insert(END,parts[0], self.state.getTag())
        
        i = 1
        l = len(parts)
        while i < l:
            self.state.change_state(parts[i])
            i = i+1
            #tags.append(parts[i])

            #tags.append(self.state.getTag())
            #self.text.insert(END,parts[i], self.state.getTag())
            i = i +1

        #print "texts=",texts,"tags=",tags
        #self.text.insert(END, parts[0], tags)
        self.text.insert(END, string.join(parts))
    
        if not self.scroll_lock:
            self.text.see(END)

            
    def clear(self):
        if self.text.index(END)>0:
            self.text.delete(1.0,END)

  
class HistoryEntry(Entry):
    def __init__(self, master,output=None,toscroll=None,client=None):
        Entry.__init__(self, master)
        self.output=output
        self.toscroll=toscroll
        self.client=client
        #self.configure(font=(("adobe", "courier" ,"normal"),14))
        self.configure(font=("-adobe-courier-bold-r-normal-*-17-120-100-100-m-100-iso8859-*",14))
        self.last_stays=1
        self.bind("<KeyPress-Return>", self.enter)
        self.bind("<KeyRelease-Up>", self.c_up)
        self.bind("<KeyRelease-Down>", self.c_down)
        self.bind("<KeyPress-Tab>",self.tab_completion)
        self.bind("<KeyPress-Prior>",self.pg_up)
        self.bind("<KeyPress-Next>",self.pg_down)
        
        self.history = []
        self.hpos = 0

    def enter(self, event):
        text = self.get()
        if self.last_stays:
            self.selection_range(0,END)
        else:
            self.delete(0,END)
        if len(text)>0:
            if len(self.history)==0 or self.history[-1] != text:
                self.history.append(text)
        self.hpos = 0

        if self.enterfun:
            self.enterfun(text)


    def set_enterfun(self, fun):
        #        print "terminal: setting enterfun to :",fun
        self.enterfun = fun

    def tab_completion(self, event):
        text = self.get()
        if (len(text) == 0):
            return "break"
        completions = []
        for t in self.history:
            if startswith(t,text) and not (t in completions):
                completions.append(t)
        c = ""
        if len(completions)>1:
            longest=completions[0]
            for t in completions:
                i=0
                for c in t:
                    if i < len(longest):
                        if c != longest[i]:
                            longest = longest[:i]
                    i = i+1
                    
            c=longest
            if self.output:
                for t in completions:
                    self.output(t)
            
        elif len(completions) == 1:
            c=completions[0]
        self.delete(0,END)
        self.insert(END,c)
        return "break"

    def history_up(self):
        if self.hpos < len(self.history):
            self.hpos = self.hpos + 1
            self.delete(0,END)
            self.insert(END, self.history[-self.hpos])
            self.selection_range(0,END)
        
    def c_up(self, event):
        self.history_up()

    def c_down(self, event):
        if self.hpos > 0:
            self.hpos = self.hpos - 1
            self.delete(0,END)
            self.insert(END, self.history[-self.hpos])
            self.selection_range(0,END)

        if self.hpos == 0:
            self.delete(0,END)

    def pg_up(self,event):
        if self.toscroll:
            self.toscroll.yview(SCROLL,-self.client.get_ioption("scrollsize"),UNITS)

    def pg_down(self,event):
        if self.toscroll:
            self.toscroll.yview(SCROLL,self.client.get_ioption("scrollsize"),UNITS)


class Terminal(Frame):
    
    def __init__(self, master):
        Frame.__init__(self, master)
        term = TermWindow(self)

        self.term = term
        master.title("Terminal window")

        
        #self.configure(borderwidth=4)
        #self.configure(relief=RAISED)
        e = Entry(self)
        e.configure(font=(("adobe", "courier" ,"normal"),14))
        e.bind("<KeyRelease-Return>", self.enter)
        e.bind("<KeyRelease-Up>", self.c_up)
        e.bind("<KeyRelease-Down>", self.c_down)


        term.pack(side=TOP,expand=YES,fill=BOTH)        
        e.pack(side=BOTTOM,expand=NO,fill=X)

#        term.grid(0)
#        e.grid(1)
        self.entry = e
        self.enterfun = self.ter_append
        self.enterfun = None

        self.history = []
        self.hpos = 0


        menu=Menu(master)
        filemenu=Menu(menu)
        menu.add_cascade(label="File",menu=filemenu)
        filemenu.add_command(label="Exit", command=self.exit)
##        filemenu.add_command(label="Load python file...",command=self.openpython)
##        filemenu.add_separator()
##        filemenu.add_command(label="Save gui config...",command=self.saveoptions)
        master.configure(menu=menu)

        
    def append(self,text):
        self.term.append(text)

    def ter_append(self,text):
        self.term.append("\n"+text)

    def enter(self, event):
        text = self.entry.get()
        #e.delete(0,END)
        self.entry.selection_range(0,END)
        if len(text)>0:
            if len(self.history)==0 or self.history[-1] != text:
                self.history.append(text)
        self.hpos = 0

        if self.enterfun:
            self.enterfun(text)


    def set_enterfun(self, fun):
        #        print "terminal: setting enterfun to :",fun
        self.enterfun = fun


    def c_up(self, event):
        if self.hpos < len(self.history):
            self.hpos = self.hpos + 1
            self.entry.delete(0,END)
            self.entry.insert(END, self.history[-self.hpos])
            self.entry.selection_range(0,END)
            

    def c_down(self, event):
        if self.hpos > 0:
            self.hpos = self.hpos - 1
            self.entry.delete(0,END)
            self.entry.insert(END, self.history[-self.hpos])
            self.entry.selection_range(0,END)

        if self.hpos == 0:
            self.entry.delete(0,END)
            
    def exit(self):
        send("quit")
        sleep(1)
        raise SystemExit

def pfun(text):
    print "text:",text





class TermOutput(Toplevel):
    def __init__(self, client, name, title="DMC", width=40, height=10, transient=None):
        Toplevel.__init__(self)
        self.title(title)
        self.client = client
        self.name = name

        if transient:
            self.transient(client.gui)
        
        term = Term.TermWindow(self,width=width,height=height)
        self.term = term
        term.pack(side=TOP,expand=YES,fill=BOTH)        

        term.set_font(client.gui.fontname)

        self.protocol("WM_DELETE_WINDOW", self.do_quit)

    def output(self, text):
        self.term.append(text)

    def do_quit(self):
        self.client.remove_win(self.name)
        #self.withdraw()

    def clear(self):
        self.term.clear()


    def set_font(self, font):
        self.term.set_font(font)

if __name__=="__main__":
    root = Tk()

    term = Terminal(root)
    
    term.pack(side=TOP,expand=YES,fill=BOTH)
    term.set_enterfun(pfun)
    #Button(text="*hallo*").pack(side=BOTTOM,expand=YES,fill=BOTH)

    mainloop()
